htools: change absolute to relative symlinks
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Use bash in order to be able to use pipefail
13 SHELL=/bin/bash
14
15 ACLOCAL_AMFLAGS = -I autotools
16 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 CHECK_MAN = $(top_srcdir)/autotools/check-man
20 CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 DOCPP = $(top_srcdir)/autotools/docpp
23 REPLACE_VARS_SED = autotools/replace_vars.sed
24 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
25
26 # Note: these are automake-specific variables, and must be named after
27 # the directory + 'dir' suffix
28 clientdir = $(pkgpythondir)/client
29 hypervisordir = $(pkgpythondir)/hypervisor
30 httpdir = $(pkgpythondir)/http
31 masterddir = $(pkgpythondir)/masterd
32 confddir = $(pkgpythondir)/confd
33 rapidir = $(pkgpythondir)/rapi
34 serverdir = $(pkgpythondir)/server
35 watcherdir = $(pkgpythondir)/watcher
36 impexpddir = $(pkgpythondir)/impexpd
37 utilsdir = $(pkgpythondir)/utils
38 toolsdir = $(pkglibdir)/tools
39 iallocatorsdir = $(pkglibdir)/iallocators
40 pytoolsdir = $(pkgpythondir)/tools
41 docdir = $(datadir)/doc/$(PACKAGE)
42
43 # Delete output file if an error occurred while building it
44 .DELETE_ON_ERROR:
45
46 HTOOLS_DIRS = \
47         htools \
48         htools/Ganeti \
49         htools/Ganeti/HTools \
50         htools/Ganeti/HTools/Program
51
52 DIRS = \
53         autotools \
54         daemons \
55         devel \
56         doc \
57         doc/examples \
58         doc/examples/hooks \
59         doc/examples/gnt-debug \
60         $(HTOOLS_DIRS) \
61         lib \
62         lib/client \
63         lib/build \
64         lib/confd \
65         lib/http \
66         lib/hypervisor \
67         lib/impexpd \
68         lib/masterd \
69         lib/rapi \
70         lib/server \
71         lib/tools \
72         lib/utils \
73         lib/watcher \
74         man \
75         qa \
76         test \
77         test/data \
78         tools
79
80 BUILDTIME_DIR_AUTOCREATE = \
81         scripts \
82         $(APIDOC_DIR) \
83         $(APIDOC_PY_DIR) \
84         $(APIDOC_HS_DIR) \
85         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
86         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
87         $(COVERAGE_DIR) \
88         $(COVERAGE_PY_DIR) \
89         $(COVERAGE_HS_DIR) \
90         .hpc
91
92 BUILDTIME_DIRS = \
93         $(BUILDTIME_DIR_AUTOCREATE) \
94         doc/html
95
96 DIRCHECK_EXCLUDE = \
97         $(BUILDTIME_DIRS) \
98         ganeti-[0-9]*.[0-9]*.[0-9]* \
99         doc/html/_*
100
101 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
102
103 # some helper vars
104 COVERAGE_DIR = doc/coverage
105 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
106 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
107 APIDOC_DIR = doc/api
108 APIDOC_PY_DIR = $(APIDOC_DIR)/py
109 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
110
111 MAINTAINERCLEANFILES = \
112         $(docpng) \
113         $(maninput) \
114         doc/install-quick.rst \
115         doc/news.rst \
116         doc/upgrade.rst \
117         vcs-version
118
119 maintainer-clean-local:
120         rm -rf $(BUILDTIME_DIRS)
121
122 CLEANFILES = \
123         $(addsuffix /*.py[co],$(DIRS)) \
124         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
125         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
126         $(all_dirfiles) \
127         $(PYTHON_BOOTSTRAP) \
128         epydoc.conf \
129         autotools/replace_vars.sed \
130         daemons/daemon-util \
131         daemons/ganeti-cleaner \
132         devel/upload \
133         doc/examples/bash_completion \
134         doc/examples/ganeti.initd \
135         doc/examples/ganeti-kvm-poweroff.initd \
136         doc/examples/ganeti.cron \
137         doc/examples/gnt-config-backup \
138         doc/examples/hooks/ipsec \
139         $(man_MANS) \
140         $(manhtml) \
141         tools/kvm-ifup \
142         stamp-srclinks \
143         $(nodist_pkgpython_PYTHON) \
144         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
145         .hpc/*.mix htools/*.tix \
146         doc/hs-lint.html
147
148 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
149 # it'll cause the target to rebuild every time.
150 BUILT_SOURCES = \
151         ganeti \
152         stamp-srclinks \
153         lib/_autoconf.py \
154         lib/_vcsversion.py \
155         $(all_dirfiles) \
156         $(PYTHON_BOOTSTRAP)
157
158 nodist_pkgpython_PYTHON = \
159         lib/_autoconf.py \
160         lib/_vcsversion.py
161
162 noinst_PYTHON = \
163         lib/build/__init__.py \
164         lib/build/sphinx_ext.py
165
166 pkgpython_PYTHON = \
167         lib/__init__.py \
168         lib/asyncnotifier.py \
169         lib/backend.py \
170         lib/bdev.py \
171         lib/bootstrap.py \
172         lib/cli.py \
173         lib/cmdlib.py \
174         lib/compat.py \
175         lib/config.py \
176         lib/constants.py \
177         lib/daemon.py \
178         lib/errors.py \
179         lib/ht.py \
180         lib/jqueue.py \
181         lib/jstore.py \
182         lib/locking.py \
183         lib/luxi.py \
184         lib/mcpu.py \
185         lib/netutils.py \
186         lib/objects.py \
187         lib/opcodes.py \
188         lib/qlang.py \
189         lib/query.py \
190         lib/rpc.py \
191         lib/runtime.py \
192         lib/serializer.py \
193         lib/ssconf.py \
194         lib/ssh.py \
195         lib/storage.py \
196         lib/uidpool.py \
197         lib/workerpool.py
198
199 client_PYTHON = \
200         lib/client/__init__.py \
201         lib/client/gnt_backup.py \
202         lib/client/gnt_cluster.py \
203         lib/client/gnt_debug.py \
204         lib/client/gnt_group.py \
205         lib/client/gnt_instance.py \
206         lib/client/gnt_job.py \
207         lib/client/gnt_node.py \
208         lib/client/gnt_os.py
209
210 hypervisor_PYTHON = \
211         lib/hypervisor/__init__.py \
212         lib/hypervisor/hv_base.py \
213         lib/hypervisor/hv_chroot.py \
214         lib/hypervisor/hv_fake.py \
215         lib/hypervisor/hv_kvm.py \
216         lib/hypervisor/hv_lxc.py \
217         lib/hypervisor/hv_xen.py
218
219 rapi_PYTHON = \
220         lib/rapi/__init__.py \
221         lib/rapi/baserlib.py \
222         lib/rapi/client.py \
223         lib/rapi/client_utils.py \
224         lib/rapi/connector.py \
225         lib/rapi/rlib2.py
226
227 http_PYTHON = \
228         lib/http/__init__.py \
229         lib/http/auth.py \
230         lib/http/client.py \
231         lib/http/server.py
232
233 confd_PYTHON = \
234         lib/confd/__init__.py \
235         lib/confd/client.py \
236         lib/confd/querylib.py \
237         lib/confd/server.py
238
239 masterd_PYTHON = \
240         lib/masterd/__init__.py \
241         lib/masterd/instance.py
242
243 impexpd_PYTHON = \
244         lib/impexpd/__init__.py
245
246 watcher_PYTHON = \
247         lib/watcher/__init__.py \
248         lib/watcher/nodemaint.py \
249         lib/watcher/state.py
250
251 server_PYTHON = \
252         lib/server/__init__.py \
253         lib/server/confd.py \
254         lib/server/masterd.py \
255         lib/server/noded.py \
256         lib/server/rapi.py
257
258 pytools_PYTHON = \
259         lib/tools/__init__.py \
260         lib/tools/ensure_dirs.py
261
262 utils_PYTHON = \
263         lib/utils/__init__.py \
264         lib/utils/algo.py \
265         lib/utils/filelock.py \
266         lib/utils/hash.py \
267         lib/utils/io.py \
268         lib/utils/log.py \
269         lib/utils/mlock.py \
270         lib/utils/nodesetup.py \
271         lib/utils/process.py \
272         lib/utils/retry.py \
273         lib/utils/text.py \
274         lib/utils/wrapper.py \
275         lib/utils/x509.py
276
277 docrst = \
278         doc/admin.rst \
279         doc/design-2.0.rst \
280         doc/design-2.1.rst \
281         doc/design-2.2.rst \
282         doc/design-2.3.rst \
283         doc/design-htools-2.3.rst \
284         doc/design-2.4.rst \
285         doc/design-draft.rst \
286         doc/design-oob.rst \
287         doc/design-cpu-pinning.rst \
288         doc/design-query2.rst \
289         doc/design-x509-ca.rst \
290         doc/design-http-server.rst \
291         doc/design-impexp2.rst \
292         doc/design-lu-generated-jobs.rst \
293         doc/design-multi-reloc.rst \
294         doc/design-network.rst \
295         doc/design-chained-jobs.rst \
296         doc/cluster-merge.rst \
297         doc/design-shared-storage.rst \
298         doc/devnotes.rst \
299         doc/glossary.rst \
300         doc/hooks.rst \
301         doc/iallocator.rst \
302         doc/index.rst \
303         doc/install-quick.rst \
304         doc/install.rst \
305         doc/locking.rst \
306         doc/move-instance.rst \
307         doc/news.rst \
308         doc/rapi.rst \
309         doc/security.rst \
310         doc/upgrade.rst \
311         doc/walkthrough.rst
312
313 HS_PROGS = htools/htools
314 HS_BIN_ROLES = hbal hscan hspace
315
316 HS_ALL_PROGS = $(HS_PROGS) htools/test
317 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
318 # we don't add -Werror by default
319 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
320 # extra flags that can be overriden on the command line
321 HEXTRA =
322 # exclude options for coverage reports
323 HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC \
324         --exclude Ganeti.Constants \
325         --exclude Ganeti.HTools.Version
326
327 HS_LIB_SRCS = \
328         htools/Ganeti/HTools/CLI.hs \
329         htools/Ganeti/HTools/Cluster.hs \
330         htools/Ganeti/HTools/Compat.hs \
331         htools/Ganeti/HTools/Container.hs \
332         htools/Ganeti/HTools/ExtLoader.hs \
333         htools/Ganeti/HTools/Group.hs \
334         htools/Ganeti/HTools/IAlloc.hs \
335         htools/Ganeti/HTools/Instance.hs \
336         htools/Ganeti/HTools/Loader.hs \
337         htools/Ganeti/HTools/Luxi.hs \
338         htools/Ganeti/HTools/Node.hs \
339         htools/Ganeti/HTools/PeerMap.hs \
340         htools/Ganeti/HTools/QC.hs \
341         htools/Ganeti/HTools/Rapi.hs \
342         htools/Ganeti/HTools/Simu.hs \
343         htools/Ganeti/HTools/Text.hs \
344         htools/Ganeti/HTools/Types.hs \
345         htools/Ganeti/HTools/Utils.hs \
346         htools/Ganeti/HTools/Program/Hail.hs \
347         htools/Ganeti/HTools/Program/Hbal.hs \
348         htools/Ganeti/HTools/Program/Hscan.hs \
349         htools/Ganeti/HTools/Program/Hspace.hs \
350         htools/Ganeti/Jobs.hs \
351         htools/Ganeti/Luxi.hs \
352         htools/Ganeti/OpCodes.hs
353
354 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
355 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
356
357 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
358
359 # Note: we use here an order-only prerequisite, as the contents of
360 # _autoconf.py are not actually influencing the html build output: it
361 # has to exist in order for the sphinx module to be loaded
362 # successfully, but we certainly don't want the docs to be rebuilt if
363 # it changes
364 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
365         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
366         | lib/_autoconf.py lib/_vcsversion.py
367         @test -n "$(SPHINX)" || \
368             { echo 'sphinx-build' not found during configure; exit 1; }
369         @mkdir_p@ $(dir $@)
370         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
371             -d . \
372             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
373             -D release="$(PACKAGE_VERSION)" \
374             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
375         rm -f doc/html/.buildinfo doc/html/objects.inv
376         touch $@
377
378 doc/html: doc/html/index.html
379
380 doc/install-quick.rst: INSTALL
381 doc/news.rst: NEWS
382 doc/upgrade.rst: UPGRADE
383
384 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
385         set -e; \
386         { echo '.. This file is automatically updated at build time from $<.'; \
387           echo '.. Do not edit.'; \
388           echo; \
389           cat $<; \
390         } > $@
391
392 docdot = \
393         doc/arch-2.0.dot \
394         doc/design-2.1-lock-acquire.dot \
395         doc/design-2.1-lock-release.dot
396
397 docpng = $(patsubst %.dot,%.png,$(docdot))
398
399 # Things to build but not to install (add it to EXTRA_DIST if it should be
400 # distributed)
401 noinst_DATA = \
402         devel/upload \
403         doc/html \
404         doc/examples/bash_completion \
405         doc/examples/ganeti.cron \
406         doc/examples/ganeti.initd \
407         doc/examples/ganeti-kvm-poweroff.initd \
408         doc/examples/gnt-config-backup \
409         doc/examples/hooks/ipsec \
410         $(manhtml)
411
412 gnt_scripts = \
413         scripts/gnt-backup \
414         scripts/gnt-cluster \
415         scripts/gnt-debug \
416         scripts/gnt-group \
417         scripts/gnt-instance \
418         scripts/gnt-job \
419         scripts/gnt-node \
420         scripts/gnt-os
421
422 PYTHON_BOOTSTRAP_SBIN = \
423         daemons/ganeti-confd \
424         daemons/ganeti-masterd \
425         daemons/ganeti-noded \
426         daemons/ganeti-watcher \
427         daemons/ganeti-rapi \
428         scripts/gnt-backup \
429         scripts/gnt-cluster \
430         scripts/gnt-debug \
431         scripts/gnt-group \
432         scripts/gnt-instance \
433         scripts/gnt-job \
434         scripts/gnt-node \
435         scripts/gnt-os
436
437 PYTHON_BOOTSTRAP = \
438         $(PYTHON_BOOTSTRAP_SBIN) \
439         tools/ensure-dirs
440
441 qa_scripts = \
442         qa/ganeti-qa.py \
443         qa/qa_cluster.py \
444         qa/qa_config.py \
445         qa/qa_daemon.py \
446         qa/qa_env.py \
447         qa/qa_error.py \
448         qa/qa_instance.py \
449         qa/qa_node.py \
450         qa/qa_os.py \
451         qa/qa_rapi.py \
452         qa/qa_tags.py \
453         qa/qa_utils.py
454
455 bin_SCRIPTS =
456 if WANT_HTOOLS
457 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
458 install-exec-hook:
459         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
460 # FIXME: this is a hardcoded logic, instead of auto-resolving
461         $(LN_S) -f ../../../bin/htools \
462                    $(DESTDIR)$(iallocatorsdir)/hail
463         for role in $(HS_BIN_ROLES); do \
464                 $(LN_S) -f htools \
465                            $(DESTDIR)$(bindir)/$$role ; \
466         done
467 endif
468
469 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
470         @if [ -z "$(HTOOLS)" ]; then \
471           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
472           exit 1; \
473         fi
474         @BINARY=$(@:htools/%=%); \
475         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
476           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
477           exit 1; \
478         fi
479         BINARY=$(@:htools/%=%); $(GHC) --make \
480           $(HFLAGS) $(HEXTRA) \
481           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
482           -osuf $$BINARY.o -hisuf $$BINARY.hi $@
483
484 # for the htools/test binary, we need to enable profiling/coverage
485 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
486         -fno-warn-monomorphism-restriction -fno-warn-orphans \
487         -fno-warn-missing-methods -fno-warn-unused-imports
488
489 dist_sbin_SCRIPTS = \
490         tools/ganeti-listrunner
491
492 nodist_sbin_SCRIPTS = \
493         $(PYTHON_BOOTSTRAP_SBIN) \
494         daemons/ganeti-cleaner
495
496 dist_tools_PYTHON = \
497         tools/burnin \
498         tools/cfgshell \
499         tools/cfgupgrade \
500         tools/cfgupgrade12 \
501         tools/cluster-merge \
502         tools/lvmstrap \
503         tools/move-instance \
504         tools/setup-ssh \
505         tools/sanitize-config
506
507 dist_tools_SCRIPTS = \
508         $(dist_tools_PYTHON) \
509         tools/kvm-console-wrapper \
510         tools/xm-console-wrapper
511
512 pkglib_python_scripts = \
513         daemons/import-export \
514         tools/check-cert-expired
515
516 nodist_pkglib_python_scripts = \
517         tools/ensure-dirs
518
519 pkglib_SCRIPTS = \
520         daemons/daemon-util \
521         tools/kvm-ifup \
522         $(pkglib_python_scripts)
523
524 nodist_pkglib_SCRIPTS = \
525         $(nodist_pkglib_python_scripts)
526
527 EXTRA_DIST = \
528         NEWS \
529         UPGRADE \
530         epydoc.conf.in \
531         pylintrc \
532         autotools/build-bash-completion \
533         autotools/check-python-code \
534         autotools/check-man \
535         autotools/check-news \
536         autotools/check-tar \
537         autotools/check-version \
538         autotools/convert-constants \
539         autotools/docpp \
540         autotools/gen-coverage \
541         autotools/testrunner \
542         $(RUN_IN_TEMPDIR) \
543         daemons/daemon-util.in \
544         daemons/ganeti-cleaner.in \
545         $(pkglib_python_scripts) \
546         devel/upload.in \
547         tools/kvm-ifup.in \
548         $(docdot) \
549         $(docpng) \
550         $(docrst) \
551         doc/conf.py \
552         doc/html \
553         doc/examples/ganeti.initd.in \
554         doc/examples/ganeti-kvm-poweroff.initd.in \
555         doc/examples/ganeti.cron.in \
556         doc/examples/gnt-config-backup.in \
557         doc/examples/ganeti.default \
558         doc/examples/ganeti.default-debug \
559         doc/examples/hooks/ethers \
560         doc/examples/hooks/ipsec.in \
561         doc/examples/gnt-debug/README \
562         doc/examples/gnt-debug/delay0.json \
563         doc/examples/gnt-debug/delay50.json \
564         test/testutils.py \
565         test/mocks.py \
566         $(dist_TESTS) \
567         $(TEST_FILES) \
568         man/footer.rst \
569         $(manrst) \
570         $(maninput) \
571         qa/qa-sample.json \
572         $(qa_scripts) \
573         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
574         $(HS_PROG_SRCS)
575
576 man_MANS = \
577         man/ganeti.7 \
578         man/ganeti-cleaner.8 \
579         man/ganeti-confd.8 \
580         man/ganeti-listrunner.8 \
581         man/ganeti-masterd.8 \
582         man/ganeti-noded.8 \
583         man/ganeti-os-interface.7 \
584         man/ganeti-rapi.8 \
585         man/ganeti-watcher.8 \
586         man/gnt-backup.8 \
587         man/gnt-cluster.8 \
588         man/gnt-debug.8 \
589         man/gnt-group.8 \
590         man/gnt-instance.8 \
591         man/gnt-job.8 \
592         man/gnt-node.8 \
593         man/gnt-os.8 \
594         man/hail.1 \
595         man/hbal.1 \
596         man/hscan.1 \
597         man/hspace.1 \
598         man/htools.1
599
600 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
601 manhtml = $(patsubst %.rst,%.html,$(manrst))
602 mangen = $(patsubst %.rst,%.gen,$(manrst))
603 maninput = \
604         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
605         $(patsubst %.html,%.html.in,$(manhtml)) \
606         man/footer.man man/footer.html $(mangen)
607
608 TEST_FILES = \
609         test/data/bdev-drbd-8.0.txt \
610         test/data/bdev-drbd-8.3.txt \
611         test/data/bdev-drbd-disk.txt \
612         test/data/bdev-drbd-net-ip4.txt \
613         test/data/bdev-drbd-net-ip6.txt \
614         test/data/cert1.pem \
615         test/data/proc_drbd8.txt \
616         test/data/proc_drbd80-emptyline.txt \
617         test/data/proc_drbd83.txt \
618         test/data/sys_drbd_usermode_helper.txt \
619         test/import-export_unittest-helper
620
621 python_tests = \
622         test/ganeti.asyncnotifier_unittest.py \
623         test/ganeti.backend_unittest.py \
624         test/ganeti.bdev_unittest.py \
625         test/ganeti.cli_unittest.py \
626         test/ganeti.client.gnt_cluster_unittest.py \
627         test/ganeti.client.gnt_instance_unittest.py \
628         test/ganeti.daemon_unittest.py \
629         test/ganeti.cmdlib_unittest.py \
630         test/ganeti.compat_unittest.py \
631         test/ganeti.confd.client_unittest.py \
632         test/ganeti.config_unittest.py \
633         test/ganeti.constants_unittest.py \
634         test/ganeti.errors_unittest.py \
635         test/ganeti.hooks_unittest.py \
636         test/ganeti.ht_unittest.py \
637         test/ganeti.http_unittest.py \
638         test/ganeti.hypervisor_unittest.py \
639         test/ganeti.hypervisor.hv_chroot_unittest.py \
640         test/ganeti.hypervisor.hv_fake_unittest.py \
641         test/ganeti.hypervisor.hv_kvm_unittest.py \
642         test/ganeti.hypervisor.hv_lxc_unittest.py \
643         test/ganeti.hypervisor.hv_xen_unittest.py \
644         test/ganeti.impexpd_unittest.py \
645         test/ganeti.jqueue_unittest.py \
646         test/ganeti.locking_unittest.py \
647         test/ganeti.luxi_unittest.py \
648         test/ganeti.masterd.instance_unittest.py \
649         test/ganeti.mcpu_unittest.py \
650         test/ganeti.netutils_unittest.py \
651         test/ganeti.objects_unittest.py \
652         test/ganeti.opcodes_unittest.py \
653         test/ganeti.qlang_unittest.py \
654         test/ganeti.query_unittest.py \
655         test/ganeti.rapi.baserlib_unittest.py \
656         test/ganeti.rapi.client_unittest.py \
657         test/ganeti.rapi.resources_unittest.py \
658         test/ganeti.rapi.rlib2_unittest.py \
659         test/ganeti.rpc_unittest.py \
660         test/ganeti.runtime_unittest.py \
661         test/ganeti.serializer_unittest.py \
662         test/ganeti.ssh_unittest.py \
663         test/ganeti.tools.ensure_dirs_unittest.py \
664         test/ganeti.uidpool_unittest.py \
665         test/ganeti.utils.algo_unittest.py \
666         test/ganeti.utils.filelock_unittest.py \
667         test/ganeti.utils.hash_unittest.py \
668         test/ganeti.utils.io_unittest.py \
669         test/ganeti.utils.log_unittest.py \
670         test/ganeti.utils.mlock_unittest.py \
671         test/ganeti.utils.nodesetup_unittest.py \
672         test/ganeti.utils.process_unittest.py \
673         test/ganeti.utils.retry_unittest.py \
674         test/ganeti.utils.text_unittest.py \
675         test/ganeti.utils.wrapper_unittest.py \
676         test/ganeti.utils.x509_unittest.py \
677         test/ganeti.utils_unittest.py \
678         test/ganeti.workerpool_unittest.py \
679         test/cfgupgrade_unittest.py \
680         test/docs_unittest.py \
681         test/tempfile_fork_unittest.py
682
683 haskell_tests = htools/test
684
685 dist_TESTS = \
686         test/check-cert-expired_unittest.bash \
687         test/daemon-util_unittest.bash \
688         test/ganeti-cleaner_unittest.bash \
689         test/import-export_unittest.bash \
690         $(python_tests)
691
692 nodist_TESTS =
693 if WANT_HTOOLSTESTS
694 nodist_TESTS += $(haskell_tests)
695 endif
696
697 TESTS = $(dist_TESTS) $(nodist_TESTS)
698
699 # Environment for all tests
700 PLAIN_TESTS_ENVIRONMENT = \
701         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
702
703 # Environment for tests run by automake
704 TESTS_ENVIRONMENT = \
705         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
706
707 all_python_code = \
708         $(dist_sbin_SCRIPTS) \
709         $(dist_tools_PYTHON) \
710         $(pkglib_python_scripts) \
711         $(nodist_pkglib_python_scripts) \
712         $(python_tests) \
713         $(pkgpython_PYTHON) \
714         $(client_PYTHON) \
715         $(hypervisor_PYTHON) \
716         $(rapi_PYTHON) \
717         $(server_PYTHON) \
718         $(pytools_PYTHON) \
719         $(http_PYTHON) \
720         $(confd_PYTHON) \
721         $(masterd_PYTHON) \
722         $(impexpd_PYTHON) \
723         $(utils_PYTHON) \
724         $(watcher_PYTHON) \
725         $(noinst_PYTHON) \
726         $(qa_scripts)
727
728 srclink_files = \
729         man/footer.rst \
730         test/check-cert-expired_unittest.bash \
731         test/daemon-util_unittest.bash \
732         test/ganeti-cleaner_unittest.bash \
733         test/import-export_unittest.bash \
734         $(all_python_code) \
735         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
736
737 check_python_code = \
738         $(BUILD_BASH_COMPLETION) \
739         $(DOCPP) \
740         $(all_python_code)
741
742 lint_python_code = \
743         ganeti \
744         ganeti/http/server.py \
745         $(dist_sbin_SCRIPTS) \
746         $(dist_tools_PYTHON) \
747         $(pkglib_python_scripts) \
748         $(BUILD_BASH_COMPLETION) \
749         $(DOCPP) \
750         $(PYTHON_BOOTSTRAP)
751
752 test/daemon-util_unittest.bash: daemons/daemon-util
753
754 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
755
756 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
757         sed -f $(REPLACE_VARS_SED) < $< > $@
758         chmod +x $@
759
760 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
761         sed -f $(REPLACE_VARS_SED) < $< > $@
762         chmod u+x $@
763
764 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
765         sed -f $(REPLACE_VARS_SED) < $< > $@
766         chmod +x $@
767
768 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
769         sed -f $(REPLACE_VARS_SED) < $< > $@
770
771 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
772         sed -f $(REPLACE_VARS_SED) < $< > $@
773
774 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
775         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
776         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
777
778 doc/%.png: doc/%.dot
779         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
780         $(DOT) -Tpng -o $@ $<
781
782 man/footer.man: man/footer.rst
783         @test -n "$(PANDOC)" || \
784           { echo 'pandoc' not found during configure; exit 1; }
785         $(PANDOC) -f rst -t man -o $@ $<
786
787 man/footer.html: man/footer.rst
788         @test -n "$(PANDOC)" || \
789           { echo 'pandoc' not found during configure; exit 1; }
790         $(PANDOC) -f rst -t html -o $@ $<
791
792 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
793         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
794
795 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
796         @test -n "$(PANDOC)" || \
797           { echo 'pandoc' not found during configure; exit 1; }
798         set -o pipefail ; \
799         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
800           sed -e 's/\\@/@/g' > $@
801         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
802
803 man/%.html.in: man/%.gen man/footer.html
804         @test -n "$(PANDOC)" || \
805           { echo 'pandoc' not found during configure; exit 1; }
806         set -o pipefail ; \
807         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
808           sed -e 's/\\@/@/g' > $@
809
810 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
811         sed -f $(REPLACE_VARS_SED) < $< > $@
812
813 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
814         sed -f $(REPLACE_VARS_SED) < $< > $@
815
816 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
817         sed -f $(REPLACE_VARS_SED) < $< > $@
818
819 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
820         sed -f $(REPLACE_VARS_SED) < $< > $@
821
822 epydoc.conf: epydoc.conf.in Makefile
823         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
824
825 vcs-version:
826         if test -d .git; then \
827           git describe > $@; \
828         elif test ! -f $@ ; then \
829           echo "Cannot auto-generate $@ file"; exit 1; \
830         fi
831
832 .PHONY: regen-vcs-version
833 regen-vcs-version:
834         set -e; \
835         cd $(srcdir); \
836         if test -d .git; then \
837           rm -f vcs-version; \
838           $(MAKE) vcs-version; \
839         fi
840
841 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
842         set -e; \
843         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
844         sed -e "s/%ver%/$$VCSVER/" < $< > $@
845
846 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
847         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS)
848         set -e; \
849         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
850
851 lib/_autoconf.py: Makefile | lib/.dir
852         set -e; \
853         { echo '# This file is automatically generated, do not edit!'; \
854           echo '#'; \
855           echo ''; \
856           echo '"""Build-time configuration for Ganeti.'; \
857           echo '';\
858           echo 'This file is autogenerated by the build process.'; \
859           echo 'For any changes you need to re-run ./configure (and'; \
860           echo 'not edit by hand).'; \
861           echo ''; \
862           echo '"""'; \
863           echo ''; \
864           echo '# pylint: disable-msg=C0301,C0324'; \
865           echo '# because this is autogenerated, we do not want'; \
866           echo '# style warnings' ; \
867           echo ''; \
868           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
869           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
870           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
871           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
872           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
873           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
874           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
875           echo "SYSCONFDIR = '$(sysconfdir)'"; \
876           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
877           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
878           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
879           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
880           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
881           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
882           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
883           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
884           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
885           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
886           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
887           echo "KVM_PATH = '$(KVM_PATH)'"; \
888           echo "SOCAT_PATH = '$(SOCAT)'"; \
889           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
890           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
891           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
892           echo "TOOLSDIR = '$(toolsdir)'"; \
893           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
894           echo "PKGLIBDIR = '$(pkglibdir)'"; \
895           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
896           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
897           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
898           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
899           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
900           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
901           echo "RAPI_USER = '$(RAPI_USER)'"; \
902           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
903           echo "CONFD_USER = '$(CONFD_USER)'"; \
904           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
905           echo "NODED_USER = '$(NODED_USER)'"; \
906           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
907           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
908           if [ "$(HTOOLS)" ]; then \
909             echo "HTOOLS = True"; \
910           else \
911             echo "HTOOLS = False"; \
912           fi; \
913         } > $@
914
915 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
916         set -e; \
917         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
918         { echo '# This file is automatically generated, do not edit!'; \
919           echo '#'; \
920           echo ''; \
921           echo '"""Build-time VCS version number for Ganeti.'; \
922           echo '';\
923           echo 'This file is autogenerated by the build process.'; \
924           echo 'For any changes you need to re-run ./configure (and'; \
925           echo 'not edit by hand).'; \
926           echo ''; \
927           echo '"""'; \
928           echo ''; \
929           echo '# pylint: disable-msg=C0301,C0324'; \
930           echo '# because this is autogenerated, we do not want'; \
931           echo '# style warnings' ; \
932           echo ''; \
933           echo "VCS_VERSION = '$$VCSVER'"; \
934         } > $@
935
936 $(REPLACE_VARS_SED): Makefile
937         set -e; \
938         { echo 's#@PREFIX@#$(prefix)#g'; \
939           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
940           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
941           echo 's#@BINDIR@#$(bindir)#g'; \
942           echo 's#@SBINDIR@#$(sbindir)#g'; \
943           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
944           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
945           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
946           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
947           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
948           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
949           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
950           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
951           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
952           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
953           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
954           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
955           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
956           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
957           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
958           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
959           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
960           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
961         } > $@
962
963 # Using deferred evaluation
964 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
965 daemons/ganeti-watcher: MODULE = ganeti.watcher
966 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
967 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
968
969 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
970         test -n "$(MODULE)" || { echo Missing module; exit 1; }
971         set -e; \
972         { echo '#!/usr/bin/python'; \
973           echo '# This file is automatically generated, do not edit!'; \
974           echo "# Edit $(MODULE) instead."; \
975           echo; \
976           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
977           echo; \
978           echo '# pylint: disable-msg=C0103'; \
979           echo '# C0103: Invalid name'; \
980           echo; \
981           echo 'import sys'; \
982           echo 'import $(MODULE) as main'; \
983           echo; \
984           echo '# Temporarily alias commands until bash completion'; \
985           echo '# generator is changed'; \
986           echo 'if hasattr(main, "commands"):'; \
987           echo '  commands = main.commands # pylint: disable-msg=E1101'; \
988           echo 'if hasattr(main, "aliases"):'; \
989           echo '  aliases = main.aliases # pylint: disable-msg=E1101'; \
990           echo; \
991           echo 'if __name__ == "__main__":'; \
992           echo '  sys.exit(main.Main())'; \
993         } > $@
994         chmod u+x $@
995
996 # We need to create symlinks because "make distcheck" will not install Python
997 # files when building.
998 stamp-srclinks: Makefile | $(all_dirfiles)
999         set -e; \
1000         for i in $(srclink_files); do \
1001                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1002                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1003                 fi; \
1004         done
1005         touch $@
1006
1007 .PHONY: ganeti
1008 ganeti:
1009         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1010
1011 .PHONY: check-dirs
1012 check-dirs: $(BUILT_SOURCES)
1013         @set -e; \
1014         find . -type d \( \( -name . \) -o \( \
1015                 -name .git -o \
1016                 -name autom4te.cache \
1017                 \) -prune -o -print \) | { \
1018                 error=; \
1019                 while read dir; do \
1020                         case "$$dir" in \
1021                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1022                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1023                         esac; \
1024                 done; \
1025                 for dir in $(DIRS); do \
1026                         if ! test -d "$$dir"; then \
1027                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1028                                 error=1; \
1029                         fi \
1030                 done; \
1031                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1032         }
1033
1034 check-local: check-dirs
1035         $(CHECK_PYTHON_CODE) $(check_python_code)
1036         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1037         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1038         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1039         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1040                 echo "Incorrect version in README, expected $$expver"; \
1041                 exit 1; \
1042         fi; \
1043         if test "`sed -ne '4 p' $(top_srcdir)/doc/iallocator.rst`" != \
1044                                         "Documents Ganeti version $$expver"; then \
1045                 echo "Incorrect version in iallocator.rst, expected $$expver"; \
1046                 exit 1; \
1047         fi
1048
1049 .PHONY: hs-check
1050 hs-check: htools/test
1051         @rm -f test.tix
1052         ./htools/test
1053
1054 .PHONY: lint
1055 lint: $(BUILT_SOURCES)
1056         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1057         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1058         cd $(top_srcdir)/qa && \
1059           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1060           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1061
1062 .PHONY: hlint
1063 hlint: $(HS_BUILT_SRCS)
1064         if tty -s; then C="-c"; else C=""; fi; \
1065         hlint --report=doc/hs-lint.html $$C htools
1066
1067 # a dist hook rule for updating the vcs-version file; this is
1068 # hardcoded due to where it needs to build the file...
1069 dist-hook:
1070         $(MAKE) regen-vcs-version && \
1071         rm -f $(top_distdir)/vcs-version && \
1072         cp -p $(srcdir)/vcs-version $(top_distdir)
1073
1074 # a distcheck hook rule for catching revision control directories
1075 distcheck-hook:
1076         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1077                 echo "Found revision control files in final archive." 1>&2; \
1078                 exit 1; \
1079         fi
1080         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1081                 echo "Found Python byte code in final archive." 1>&2; \
1082                 exit 1; \
1083         fi
1084         if find $(top_distdir) -name '*~' | grep .; then \
1085                 echo "Found backup files in final archive." 1>&2; \
1086                 exit 1; \
1087         fi
1088 # Empty files or directories should not be distributed. They can cause
1089 # unnecessary warnings for packagers. Directories used by automake during
1090 # distcheck must be excluded.
1091         if find $(top_distdir) -empty -and -not \( \
1092                         -path $(top_distdir)/_build -or \
1093                         -path $(top_distdir)/_inst \) | grep .; then \
1094                 echo "Found empty files or directories in final archive." 1>&2; \
1095                 exit 1; \
1096         fi
1097         if test -n "$(BUILD_RELEASE)" && \
1098            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1099                 echo "Found unreleased version in NEWS." >&2; \
1100                 exit 1; \
1101         fi
1102
1103 # When building a release, stricter checks should be used
1104 distcheck-release dist-release: export BUILD_RELEASE = 1
1105 distcheck-release: distcheck
1106
1107 dist-release: dist
1108         set -e; \
1109         for i in $(DIST_ARCHIVES); do \
1110                 echo -n "Checking $$i ... "; \
1111                 autotools/check-tar < $$i; \
1112                 echo OK; \
1113         done
1114
1115 install-exec-local:
1116         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1117           "$(DESTDIR)${localstatedir}/log/ganeti" \
1118           "$(DESTDIR)${localstatedir}/run/ganeti"
1119
1120 # To avoid conflicts between directory names and other targets, a file inside
1121 # the directory is used to ensure its existence.
1122 %.dir:
1123         @mkdir_p@ $* && touch $@
1124
1125 .PHONY: apidoc
1126 if WANT_HTOOLSAPIDOC
1127 apidoc: py-apidoc hs-apidoc
1128 else
1129 apidoc: py-apidoc
1130 endif
1131
1132 .PHONY: py-apidoc
1133 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1134         $(RUN_IN_TEMPDIR) epydoc -v \
1135                 --conf $(CURDIR)/epydoc.conf \
1136                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1137
1138 .PHONY: hs-apidoc
1139 hs-apidoc: $(HS_BUILT_SRCS)
1140         @test -n "$(HSCOLOUR)" || \
1141             { echo 'HsColour' not found during configure; exit 1; }
1142         @test -n "$(HADDOCK)" || \
1143             { echo 'haddock' not found during configure; exit 1; }
1144         rm -rf $(APIDOC_HS_DIR)/*
1145         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1146         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1147         ln -s ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1148         set -e ; \
1149         cd htools; \
1150         if [ "$(HTOOLS_NOCURL)" ]; \
1151         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1152         else OPTGHC=""; \
1153         fi; \
1154         if [ "$(HTOOLS_PARALLEL3)" ]; \
1155         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1156         fi; \
1157         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1158         for file in $$RELSRCS; do \
1159                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1160                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1161         done ; \
1162         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1163                 -t ganeti-htools -p haddock-prologue \
1164                 --source-module="%{MODULE/.//}.html" \
1165                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1166                 $$OPTGHC \
1167                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1168
1169 .PHONY: TAGS
1170 TAGS: $(BUILT_SOURCES)
1171         rm -f TAGS
1172         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1173           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1174           -path './qa/*.py' | \
1175           etags -l python -
1176
1177 .PHONY: coverage
1178 if WANT_HTOOLS
1179 coverage: py-coverage hs-coverage
1180 else
1181 coverage: py-coverage
1182 endif
1183
1184 .PHONY: py-coverage
1185 py-coverage: $(BUILT_SOURCES) $(python_tests)
1186         set -e; \
1187         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1188         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1189         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1190         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1191         $(python_tests)
1192
1193 .PHONY: hs-coverage
1194 hs-coverage: $(haskell_tests)
1195         cd htools && rm -f *.tix *.mix && ./test
1196         @mkdir_p@ $(COVERAGE_HS_DIR)
1197         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1198         hpc report htools/test $(HPCEXCL)
1199         ln -sf hpc_index.html $(COVERAGE_HS_DIR)/index.html
1200
1201 # Special "kind-of-QA" target for htools, needs special setup (all
1202 # tools compiled with -fhpc)
1203 .PHONY: live-test
1204 live-test: all
1205         set -e ; \
1206         cd htools; \
1207         rm -f .hpc; ln -s ../.hpc .hpc; \
1208         rm -f *.tix *.mix; \
1209         ./live-test.sh; \
1210         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1211           --output=live-test.tix ; \
1212         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1213         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1214                 --srcdir=.. $(HPCEXCL) ; \
1215         hpc report --srcdir=.. live-test $(HPCEXCL)
1216
1217 commit-check: distcheck lint apidoc
1218
1219 -include ./Makefile.local
1220
1221 # vim: set noet :